package jrummikub.control.network;

import java.awt.Color;
import java.util.UUID;

import jrummikub.util.GameData;
import jrummikub.util.IEvent;
import jrummikub.util.IEvent1;
import jrummikub.util.IEvent2;

interface IConnectionControl {

	public String getNickname();

	public void connect();

	public void disconnect();

	public IEvent getConnectedEvent();

	public IEvent getConnectionFailedEvent();

	public IEvent1<GameData> getGameOfferEvent();

	public IEvent1<UUID> getGameWithdrawalEvent();

	public IEvent1<String> getGameJoinEvent();

	public IEvent1<String> getGameLeaveEvent();

	public IEvent1<Boolean> getGameJoinAckEvent();

	public IEvent2<String, Color> getChangeColorEvent();

	public IEvent getGameStartEvent();

	public void offerGame(GameData data);

	public void withdrawGame();

	public GameData getCurrentGame();

	public void setCurrentGame(GameData game);

	public void joinGame(final GameData game);

	public void leaveGame();

	public void ackJoinGame(final String recipient, final boolean ack);

	public void changeColor(final Color color);

	public void startGame();

}