package jrummikub.model;

import java.io.Serializable;

/**
 * Interface for {@link Player} model
 */
public interface IPlayer extends Serializable {

	/**
	 * Get the current hand of the player
	 * 
	 * @return the player's hand
	 */
	public IHand getHand();

	/**
	 * Set the current hand of the player
	 * 
	 * @param hand
	 *          the new hand
	 */
	public void setHand(IHand hand);

	/**
	 * Has the player laid out yet?
	 * 
	 * @return if the player has laid out
	 */
	public boolean getLaidOut();

	/**
	 * Returns the player settings
	 * 
	 * @return the player settings
	 */
	public PlayerSettings getPlayerSettings();

	/**
	 * Set if the player laid out
	 * 
	 * @param laidOut
	 *          the player laid out
	 * 
	 */
	void setLaidOut(boolean laidOut);
}